diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/examples/routing/global-injection-slash32.cc ns-3.47/examples/routing/global-injection-slash32.cc
--- ns-3.46/examples/routing/global-injection-slash32.cc	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/examples/routing/global-injection-slash32.cc	2026-02-16 16:08:49.558229700 -0800
@@ -11,9 +11,9 @@
 #include "ns3/core-module.h"
 #include "ns3/csma-net-device.h"
 #include "ns3/global-router-interface.h"
+#include "ns3/global-routing.h"
 #include "ns3/internet-module.h"
 #include "ns3/ipv4-global-routing-helper.h"
-#include "ns3/ipv4-global-routing.h"
 #include "ns3/ipv4-list-routing-helper.h"
 #include "ns3/ipv4-list-routing.h"
 #include "ns3/ipv4-routing-table-entry.h"
@@ -110,7 +110,7 @@
     // Populate routing tables for nodes nA and nB
     Ipv4GlobalRoutingHelper::PopulateRoutingTables();
     // Inject global routes from Node B, including transit network...
-    Ptr<GlobalRouter> globalRouterB = nB->GetObject<GlobalRouter>();
+    Ptr<Ipv4GlobalRouter> globalRouterB = nB->GetObject<Ipv4GlobalRouter>();
     globalRouterB->InjectRoute("10.1.1.4", "255.255.255.252");
     // ...and the host in network "C"
     globalRouterB->InjectRoute("192.168.1.1", "255.255.255.255");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/examples/stats/wifi-example-apps.h ns-3.47/examples/stats/wifi-example-apps.h
--- ns-3.46/examples/stats/wifi-example-apps.h	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/examples/stats/wifi-example-apps.h	2026-02-16 16:08:49.559229600 -0800
@@ -13,6 +13,9 @@
  *
  */
 
+#ifndef WIFI_EXAMPLE_APPS_H
+#define WIFI_EXAMPLE_APPS_H
+
 #include "ns3/application.h"
 #include "ns3/core-module.h"
 #include "ns3/network-module.h"
@@ -115,3 +118,5 @@
     Ptr<CounterCalculator<>> m_calc;           //!< Counter of the number of received packets
     Ptr<TimeMinMaxAvgTotalCalculator> m_delay; //!< Delay calculator
 };
+
+#endif // WIFI_EXAMPLE_APPS_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/examples/tcp/CMakeLists.txt ns-3.47/examples/tcp/CMakeLists.txt
--- ns-3.46/examples/tcp/CMakeLists.txt	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/examples/tcp/CMakeLists.txt	2026-02-16 16:08:49.560229800 -0800
@@ -28,6 +28,19 @@
 )
 
 build_example(
+  NAME tcp-ecn-example
+  SOURCE_FILES tcp-ecn-example.cc
+  LIBRARIES_TO_LINK
+    ${libpoint-to-point}
+    ${libinternet}
+    ${libapplications}
+    ${libtraffic-control}
+    ${libnetwork}
+    ${libinternet-apps}
+    ${libflow-monitor}
+)
+
+build_example(
   NAME tcp-bbr-example
   SOURCE_FILES tcp-bbr-example.cc
   LIBRARIES_TO_LINK
@@ -112,3 +125,15 @@
     ${libapplications}
     ${libtraffic-control}
 )
+build_example(
+  NAME fack-example
+  SOURCE_FILES fack-example.cc
+  LIBRARIES_TO_LINK
+    ${libinternet}
+    ${libpoint-to-point}
+    ${libapplications}
+    ${libtraffic-control}
+    ${libnetwork}
+    ${libinternet-apps}
+    ${libflow-monitor}
+)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/examples/tcp/examples-to-run.py ns-3.47/examples/tcp/examples-to-run.py
--- ns-3.46/examples/tcp/examples-to-run.py	2025-10-01 18:46:32.000000000 -0700
+++ ns-3.47/examples/tcp/examples-to-run.py	2026-02-16 16:08:49.560229800 -0800
@@ -31,6 +31,11 @@
         "True",
         "True",
     ),
+    (
+        "tcp-ecn-example --stopTime=20s",
+        "True",
+        "False",
+    ),
 ]
 
 # A list of Python examples to run in order to ensure that they remain
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/examples/tcp/fack-example.cc ns-3.47/examples/tcp/fack-example.cc
--- ns-3.46/examples/tcp/fack-example.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.47/examples/tcp/fack-example.cc	2026-02-16 16:08:49.560229800 -0800
@@ -0,0 +1,427 @@
+/*
+ * Copyright (c) 2018-20, 2025 NITK Surathkal
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Authors: Aarti Nandagiri <aarti.nandagiri@gmail.com>
+ *          Vivek Jain <jain.vivek.anand@gmail.com>
+ *          Mohit P. Tahiliani <tahiliani@nitk.edu.in>
+ *
+ * Modified for FACK by: Jayesh Akot <akotjayesh@gmail.com>
+ */
+
+/**
+ * @file
+ * @ingroup examples-tcp
+ * @brief Example to verify TCP FACK performance based on Mathis & Mahdavi paper.
+ *
+ * The network topology used in this example is based on the Fig. 1 described in
+ * Mathis, M., & Mahdavi, J. (1996, August).
+ * Forward acknowledgement: Refining TCP congestion control.
+ *
+ * @code{.text}
+ *            10 Mbps           1.5 Mbps          10 Mbps
+ * Sender -------------- R1 -------------- R2 -------------- Receiver
+ *              2ms               5ms               33ms
+ * @endcode
+ *
+ * This program runs by default for 100 seconds and creates a new directory
+ * called 'fack-results' in the ns-3 root directory. The program creates one
+ * sub-directory called 'pcap' in 'fack-results' directory (if pcap generation
+ * is enabled) and six .dat files.
+ *
+ * - 'pcap' sub-directory contains six PCAP files:
+ *  - fack-0-0.pcap for the interface on Sender
+ *  - fack-1-0.pcap for the interface on Receiver
+ *  - fack-2-0.pcap for the first interface on R1
+ *  - fack-2-1.pcap for the second interface on R1
+ *  - fack-3-0.pcap for the first interface on R2
+ *  - fack-3-1.pcap for the second interface on R2
+ * - cwnd.dat file contains congestion window trace for the sender node
+ * - throughput.dat file contains sender side throughput trace (throughput is in Mbit/s)
+ * - queueSize.dat file contains queue length trace from the bottleneck link
+ * - lostSegments.dat file contains packet lost trace at queue
+ * - bytesInFlight.dat contains trace of inflight data(SND.NXT - SND.UNA).
+ * - fackAwnd.dat contains trace of the FACK-specific inflight estimate.
+ *
+ * This example allows the user to quantitatively verify two key mechanisms
+ * described in the Mathis & Mahdavi paper:
+ * -# The preservation of the TCP Self-Clock during recovery (Section 4.2).
+ * -# The "Overdamping" mechanism to drain queues after overshoot (Section 4.4).
+ *
+ * To observe these insights, you must run the simulation twice with different configurations:
+ *
+ * - **Step 1:** Run with FACK enabled (Default)
+ * @code ./ns3 run "fack-example --fack=true" @endcode
+ *
+ * - **Step 2:** Run with FACK disabled (Standard Reno+SACK behavior)
+ * @code ./ns3 run "fack-example --fack=false" @endcode
+ *
+ * - **Step 3:** Compare the output traces 'bytesInFlight.dat' and 'cwnd.dat' from both runs.
+ *
+ * **SPECIFIC OBSERVATIONS:**
+ *
+ * **A. Preservation of Self-Clock (Compare 'bytesInFlight.dat'):**
+ * - WITHOUT FACK: When multiple packet losses occur (approx t=0.5s), the
+ * inflight data drops significantly (often stalling near zero). This indicates
+ * a loss of the ACK clock, matching the behavior of "Reno+SACK" described
+ * in Section 4.2 and Figure 3 of the paper.
+ * - WITH FACK: The inflight data remains elevated even during recovery.
+ * This demonstrates that FACK successfully decouples congestion control
+ * from data recovery, using SACK blocks to inject new data and maintain
+ * the self-clock. This matches the behavior in Figure 4 of the paper.
+ *
+ * **B. Overdamping and Queue Draining (Compare 'cwnd.dat' vs 'bytesInFlight.dat'):**
+ * - In the FACK run (between t=1.0s and t=2.0s), observe that 'cwnd' drops
+ * to a low value (~10 packets) while 'bytesInFlight' remains high (~50 packets).
+ * - This divergence is the "Overdamping" mechanism (Section 4.4). FACK detects
+ * that the actual data in the network (inflight) exceeds the target window
+ * (cwnd) due to the initial Slow-Start overshoot.
+ * - Consequently, FACK inhibits transmission (visible as a throughput dip) to
+ * allow the excess queue to drain.
+ */
+#include "ns3/applications-module.h"
+#include "ns3/core-module.h"
+#include "ns3/flow-monitor-module.h"
+#include "ns3/internet-module.h"
+#include "ns3/network-module.h"
+#include "ns3/point-to-point-module.h"
+#include "ns3/traffic-control-module.h"
+
+using namespace ns3;
+using namespace ns3::SystemPath;
+
+std::string g_dir;                      //!< Output directory
+std::ofstream g_throughput;             //!< Throughput output stream
+std::ofstream g_queueSize;              //!< Queue size output stream
+std::ofstream g_individualLostSegments; //!< Lost segments output stream
+
+uint32_t g_prev = 0;           //!< Previous throughput byte count
+Time g_prevTime;               //!< Previous throughput measurement time
+uint32_t g_segmentSize = 1448; //!< Segment size
+
+/**
+ * @brief Calculate and trace throughput
+ * @param monitor The flow monitor
+ */
+static void
+TraceThroughput(Ptr<FlowMonitor> monitor)
+{
+    FlowMonitor::FlowStatsContainer stats = monitor->GetFlowStats();
+    if (!stats.empty())
+    {
+        auto itr = stats.begin();
+        Time curTime = Now();
+        // Convert (curTime - prevTime) to microseconds so that throughput is in bits per
+        // microsecond (which is equivalent to Mbps)
+
+        g_throughput << curTime.GetSeconds() << "s "
+                     << 8 * (itr->second.txBytes - g_prev) /
+                            ((curTime - g_prevTime).ToDouble(Time::US))
+                     << " Mbps" << std::endl;
+        g_prevTime = curTime;
+        g_prev = itr->second.txBytes;
+    }
+    Simulator::Schedule(Seconds(0.2), &TraceThroughput, monitor);
+}
+
+/**
+ * @brief Check and trace the queue size
+ * @param qd The queue disc
+ */
+void
+CheckQueueSize(Ptr<QueueDisc> qd)
+{
+    uint32_t qsize = qd->GetCurrentSize().GetValue();
+    Simulator::Schedule(Seconds(0.2), &CheckQueueSize, qd);
+    g_queueSize << Simulator::Now().GetSeconds() << " " << qsize << std::endl;
+}
+
+/**
+ * @brief Trace packets dropped at Queue
+ * @param stream The output stream
+ * @param item The queue disc item dropped
+ */
+static void
+TracePacketDrop(Ptr<OutputStreamWrapper> stream, Ptr<const QueueDiscItem> item)
+{
+    Ptr<const Packet> p = item->GetPacket();
+
+    TcpHeader tcpHeader;
+    p->PeekHeader(tcpHeader);
+    uint32_t seqNum = tcpHeader.GetSequenceNumber().GetValue();
+
+    // The plots in the paper use segment index, not the raw sequence number.
+    // We calculate it by dividing by the segment size.
+    double segmentIndex = static_cast<double>(seqNum) / g_segmentSize;
+
+    *stream->GetStream() << Simulator::Now().GetSeconds() << " " << segmentIndex << std::endl;
+}
+
+/**
+ * @brief Trace congestion window
+ * @param stream The output stream
+ * @param oldval Old value
+ * @param newval New value
+ */
+static void
+CwndTracer(Ptr<OutputStreamWrapper> stream, uint32_t oldval, uint32_t newval)
+{
+    *stream->GetStream() << Simulator::Now().GetSeconds() << " " << newval / g_segmentSize
+                         << std::endl;
+}
+
+/**
+ * @brief Trace BytesInFlight in segments
+ * @param stream The output stream
+ * @param oldval Old value
+ * @param newval New value
+ */
+static void
+BytesInFlightTracer(Ptr<OutputStreamWrapper> stream, uint32_t oldval, uint32_t newval)
+{
+    uint32_t segs = newval / g_segmentSize;
+    *stream->GetStream() << Simulator::Now().GetSeconds() << " " << segs << std::endl;
+}
+
+/**
+ * @brief Trace FACK's inflight(AWND) in segments
+ * @param stream The output stream
+ * @param oldval Old value
+ * @param newval New value
+ */
+static void
+FackAwndTracer(Ptr<OutputStreamWrapper> stream, uint32_t oldval, uint32_t newval)
+{
+    uint32_t segs = newval / g_segmentSize;
+    *stream->GetStream() << Simulator::Now().GetSeconds() << " " << segs << std::endl;
+}
+
+/**
+ * @brief Bind the Congestion Window trace source.
+ * @param nodeId The node ID.
+ * @param socketId The socket ID.
+ */
+void
+TraceCwnd(uint32_t nodeId, uint32_t socketId)
+{
+    AsciiTraceHelper ascii;
+    Ptr<OutputStreamWrapper> stream = ascii.CreateFileStream(g_dir + "/cwnd.dat");
+    Config::ConnectWithoutContext("/NodeList/" + std::to_string(nodeId) +
+                                      "/$ns3::TcpL4Protocol/SocketList/" +
+                                      std::to_string(socketId) + "/CongestionWindow",
+                                  MakeBoundCallback(&CwndTracer, stream));
+}
+
+/**
+ * @brief Bind the BytesInFlight trace source.
+ * @param nodeId The node ID.
+ * @param socketId The socket ID.
+ */
+void
+TraceBytesInFlight(uint32_t nodeId, uint32_t socketId)
+{
+    AsciiTraceHelper ascii;
+    Ptr<OutputStreamWrapper> stream = ascii.CreateFileStream(g_dir + "/bytesInFlight.dat");
+    Config::ConnectWithoutContext("/NodeList/" + std::to_string(nodeId) +
+                                      "/$ns3::TcpL4Protocol/SocketList/" +
+                                      std::to_string(socketId) + "/BytesInFlight",
+                                  MakeBoundCallback(&BytesInFlightTracer, stream));
+}
+
+/**
+ * @brief Bind the FackAwnd trace source.
+ * @param nodeId The node ID.
+ * @param socketId The socket ID.
+ */
+void
+TraceFackAwnd(uint32_t nodeId, uint32_t socketId)
+{
+    AsciiTraceHelper ascii;
+    Ptr<OutputStreamWrapper> stream = ascii.CreateFileStream(g_dir + "/fackAwnd.dat");
+    Config::ConnectWithoutContext("/NodeList/" + std::to_string(nodeId) +
+                                      "/$ns3::TcpL4Protocol/SocketList/" +
+                                      std::to_string(socketId) + "/FackAwnd",
+                                  MakeBoundCallback(&FackAwndTracer, stream));
+}
+
+int
+main(int argc, char* argv[])
+{
+    // Naming the output directory using local system time
+    time_t rawtime;
+    struct tm* timeinfo;
+    char buffer[80];
+    time(&rawtime);
+    timeinfo = localtime(&rawtime);
+    strftime(buffer, sizeof(buffer), "%d-%m-%Y-%I-%M-%S", timeinfo);
+    std::string currentTime(buffer);
+
+    std::string tcpTypeId = "TcpLinuxReno";
+    std::string queueDisc = "FifoQueueDisc";
+    uint32_t delAckCount = 2;
+    bool bql = true;
+    bool enablePcap = false;
+    bool sack = true;
+    bool fack = true;
+    Time stopTime = Seconds(10);
+
+    queueDisc = std::string("ns3::") + queueDisc;
+
+    Config::SetDefault("ns3::TcpSocket::SndBufSize", UintegerValue(4194304));
+    Config::SetDefault("ns3::TcpSocket::RcvBufSize", UintegerValue(6291456));
+    Config::SetDefault("ns3::TcpSocket::InitialCwnd", UintegerValue(10));
+    Config::SetDefault("ns3::TcpSocket::DelAckCount", UintegerValue(delAckCount));
+    Config::SetDefault("ns3::TcpSocket::SegmentSize", UintegerValue(g_segmentSize));
+    Config::SetDefault("ns3::TcpSocket::InitialSlowStartThreshold",
+                       UintegerValue(35 * g_segmentSize));
+    Config::SetDefault("ns3::DropTailQueue<Packet>::MaxSize", QueueSizeValue(QueueSize("1p")));
+    Config::SetDefault(queueDisc + "::MaxSize", QueueSizeValue(QueueSize("10p")));
+    Config::SetDefault("ns3::TcpSocketBase::Sack", BooleanValue(sack));
+
+    CommandLine cmd(__FILE__);
+    cmd.AddValue("tcpTypeId", "Transport protocol to use: TcpLinuxReno", tcpTypeId);
+    cmd.AddValue("enablePcap", "Enable/Disable pcap file generation", enablePcap);
+    cmd.AddValue("stopTime",
+                 "Stop time for applications / simulation time will be stopTime + 1",
+                 stopTime);
+    cmd.AddValue("fack", "Enable/Disable FACK", fack);
+
+    cmd.Parse(argc, argv);
+
+    Config::SetDefault("ns3::TcpL4Protocol::SocketType", StringValue("ns3::" + tcpTypeId));
+    Config::SetDefault("ns3::TcpSocketBase::Fack", BooleanValue(fack));
+
+    // The maximum send buffer size is set to 4194304 bytes (4MB) and the
+    // maximum receive buffer size is set to 6291456 bytes (6MB) in the Linux
+    // kernel. The same buffer sizes are used as default in this example.
+
+    AsciiTraceHelper asciiTraceHelper;
+    Ptr<OutputStreamWrapper> streamWrapper;
+
+    NodeContainer sender;
+    NodeContainer receiver;
+    NodeContainer routers;
+    sender.Create(1);
+    receiver.Create(1);
+    routers.Create(2);
+
+    // Create the point-to-point link helpers
+    PointToPointHelper bottleneckLink;
+    bottleneckLink.SetDeviceAttribute("DataRate", StringValue("1.5Mbps"));
+    bottleneckLink.SetChannelAttribute("Delay", StringValue("5ms"));
+
+    PointToPointHelper senderToR1;
+    senderToR1.SetDeviceAttribute("DataRate", StringValue("10Mbps"));
+    senderToR1.SetChannelAttribute("Delay", StringValue("2ms"));
+
+    PointToPointHelper r2ToReceiver;
+    r2ToReceiver.SetDeviceAttribute("DataRate", StringValue("10Mbps"));
+    r2ToReceiver.SetChannelAttribute("Delay", StringValue("33ms"));
+
+    // Create NetDevice containers
+    NetDeviceContainer senderEdge = senderToR1.Install(sender.Get(0), routers.Get(0));
+    NetDeviceContainer r1r2 = bottleneckLink.Install(routers.Get(0), routers.Get(1));
+    NetDeviceContainer receiverEdge = r2ToReceiver.Install(routers.Get(1), receiver.Get(0));
+
+    // Install Stack
+    InternetStackHelper internet;
+    internet.Install(sender);
+    internet.Install(receiver);
+    internet.Install(routers);
+
+    // Configure the root queue discipline
+    TrafficControlHelper tch;
+    tch.SetRootQueueDisc(queueDisc);
+
+    if (bql)
+    {
+        tch.SetQueueLimits("ns3::DynamicQueueLimits", "HoldTime", StringValue("1000ms"));
+    }
+
+    tch.Install(senderEdge);
+    tch.Install(receiverEdge);
+
+    // Assign IP addresses
+    Ipv4AddressHelper ipv4;
+    ipv4.SetBase("10.0.0.0", "255.255.255.0");
+
+    Ipv4InterfaceContainer i1i2 = ipv4.Assign(r1r2);
+
+    ipv4.NewNetwork();
+    Ipv4InterfaceContainer is1 = ipv4.Assign(senderEdge);
+
+    ipv4.NewNetwork();
+    Ipv4InterfaceContainer ir1 = ipv4.Assign(receiverEdge);
+
+    // Populate routing tables
+    Ipv4GlobalRoutingHelper::PopulateRoutingTables();
+
+    // Select sender side port
+    uint16_t port = 50001;
+
+    // Install application on the sender
+    BulkSendHelper source("ns3::TcpSocketFactory", InetSocketAddress(ir1.GetAddress(1), port));
+    source.SetAttribute("MaxBytes", UintegerValue(0));
+    ApplicationContainer sourceApps = source.Install(sender.Get(0));
+    sourceApps.Start(Seconds(0.1));
+    // Hook trace source after application starts
+    Simulator::Schedule(Seconds(0.1) + MilliSeconds(1), &TraceCwnd, 0, 0);
+    Simulator::Schedule(Seconds(0.1) + MilliSeconds(1), &TraceBytesInFlight, 0, 0);
+    Simulator::Schedule(Seconds(0.1) + MilliSeconds(1), &TraceFackAwnd, 0, 0);
+    sourceApps.Stop(stopTime);
+
+    // Install application on the receiver
+    PacketSinkHelper sink("ns3::TcpSocketFactory", InetSocketAddress(Ipv4Address::GetAny(), port));
+    ApplicationContainer sinkApps = sink.Install(receiver.Get(0));
+    sinkApps.Start(Seconds(0));
+    sinkApps.Stop(stopTime);
+
+    // Create a new directory to store the output of the program
+    g_dir = "fack-results/" + currentTime + "/";
+    MakeDirectories(g_dir);
+
+    // Open the lostSegments.dat file and write packet-loss events into it.
+    g_individualLostSegments.open(g_dir + "/lostSegments.dat", std::ios::out);
+    Ptr<OutputStreamWrapper> streamWrapperIndivLost =
+        asciiTraceHelper.CreateFileStream(g_dir + "/lostSegments.dat");
+
+    // Trace the queue occupancy on the second interface of R1
+    tch.Uninstall(routers.Get(0)->GetDevice(1));
+    QueueDiscContainer qd;
+    qd = tch.Install(routers.Get(0)->GetDevice(1));
+
+    // Get the actual QueueDisc Ptr and connect the "Drop" trace source
+    Ptr<QueueDisc> q = qd.Get(0);
+    q->TraceConnectWithoutContext("Drop",
+                                  MakeBoundCallback(&TracePacketDrop, streamWrapperIndivLost));
+
+    Simulator::ScheduleNow(&CheckQueueSize, qd.Get(0));
+    // Generate PCAP traces if it is enabled
+    if (enablePcap)
+    {
+        MakeDirectories(g_dir + "pcap/");
+        bottleneckLink.EnablePcapAll(g_dir + "/pcap/fack", true);
+    }
+
+    // Open files for writing throughput traces and queue size
+    g_throughput.open(g_dir + "/throughput.dat", std::ios::out);
+    g_queueSize.open(g_dir + "/queueSize.dat", std::ios::out);
+
+    NS_ASSERT_MSG(g_throughput.is_open(), "Throughput file was not opened correctly");
+    NS_ASSERT_MSG(g_queueSize.is_open(), "Queue size file was not opened correctly");
+
+    // Check for dropped packets using Flow Monitor
+    FlowMonitorHelper flowmon;
+    Ptr<FlowMonitor> monitor = flowmon.InstallAll();
+    Simulator::Schedule(Seconds(0 + 0.000001), &TraceThroughput, monitor);
+
+    Simulator::Stop(stopTime + TimeStep(1));
+    Simulator::Run();
+    Simulator::Destroy();
+
+    g_throughput.close();
+    g_queueSize.close();
+
+    return 0;
+}
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.46/examples/tcp/tcp-bbr-example.py ns-3.47/examples/tcp/tcp-bbr-example.py
--- ns-3.46/examples/tcp/tcp-bbr-example.py	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.47/examples/tcp/tcp-bbr-example.py	2026-02-16 16:08:49.560229800 -0800
@@ -0,0 +1,280 @@
+# SPDX-License-Identifier: GPL-2.0-only
+#
+# Copyright (c) 2018-20 NITK Surathkal
+# Copyright (c) 2025 CSPIT, CHARUSAT
+#
+# Authors:
+#   Aarti Nandagiri <aarti.nandagiri@gmail.com>
+#   Vivek Jain <jain.vivek.anand@gmail.com>
+#   Mohit P. Tahiliani <tahiliani@nitk.edu.in>
+#   Urval Kheni <kheniurval777@gmail.com>
+#   Ritesh Patel <riteshpatel.ce@charusat.ac.in>
+
+"""
+Python port of tcp-bbr-example.cc
+
+Simulates the following topology:
+
+    Sender ---- R1 ---- R2 ---- Receiver
+     1000Mbps    10Mbps   1000Mbps
+       5ms        10ms       5ms
+
+Outputs:
+- cwnd.dat        (congestion window)
+- throughput.dat  (throughput)
+- queueSize.dat   (queue length)
+"""
+
+import argparse
+import os
+import time
+
+try:
+    from ns import ns
+except ModuleNotFoundError:
+    raise SystemExit(
+        "Error: ns3 Python module not found. "
+        "Bindings may not be enabled or PYTHONPATH is incorrect."
+    )
+
+# Global trace variables
+prev_tx = 0
+prev_time = None
+throughput_file = None
+queue_file = None
+cwnd_file = None
+outdir = ""
+
+
+def trace_throughput_callback():
+    """Throughput trace callback."""
+    global prev_tx, prev_time, throughput_file
+
+    stats = ns.cppyy.gbl.monitor_ptr.GetFlowStats()
+    if stats and not stats.empty():
+        flow_stats = stats.begin().__deref__().second
+        cur_time = ns.Now()
+
+        bits = 8 * (flow_stats.txBytes - prev_tx)
+        us = (cur_time - prev_time).ToDouble(ns.Time.US)
+
+        if us > 0:
+            throughput_file.write(f"{cur_time.GetSeconds():.6g}s {bits / us:.6g} Mbps\n")
+            throughput_file.flush()
+
+        prev_time = cur_time
+        prev_tx = flow_stats.txBytes
+
+
+def check_queue_size_callback():
+    """Queue length tracer."""
+    global queue_file
+
+    q = ns.cppyy.gbl.qdisc_ptr.GetCurrentSize().GetValue()
+    queue_file.write(f"{ns.Simulator.Now().GetSeconds():.6g} {q}\n")
+    queue_file.flush()
+
+
+def trace_cwnd_callback(oldval, newval):
+    """Congestion window tracer."""
+    global cwnd_file
+
+    cwnd_file.write(f"{ns.Simulator.Now().GetSeconds():.6g} {newval / 1448.0:.6g}\n")
+    cwnd_file.flush()
+
+
+# C++ helper functions for scheduling Python callbacks
+ns.cppyy.cppdef(r"""
+#include "ns3/simulator.h"
+#include "ns3/flow-monitor-helper.h"
+#include "ns3/queue-disc.h"
+#include "ns3/node.h"
+#include "ns3/config.h"
+
+using namespace ns3;
+
+Ptr<FlowMonitor> monitor_ptr;
+Ptr<QueueDisc> qdisc_ptr;
+
+// Helper to create event from Python callback without parameters
+EventImpl* pythonMakeEvent(void (*f)())
+{
+    return MakeEvent(f);
+}
+
+// Helper to connect cwnd callback and create event
+EventImpl* pythonConnectCwndTrace(void (*f)(uint32_t, uint32_t))
+{
+    Config::ConnectWithoutContext(
+        "/NodeList/0/$ns3::TcpL4Protocol/SocketList/0/CongestionWindow",
+        MakeCallback(f));
+    return nullptr;
+}
+""")
+
+
+def main():
+    global throughput_file, queue_file, cwnd_file, outdir, prev_time
+    global prev_tx
+
+    parser = argparse.ArgumentParser(description="tcp-bbr-example (Python)")
+    parser.add_argument(
+        "--tcpTypeId",
+        default="TcpBbr",
+        help="Transport protocol: TcpNewReno, TcpBbr",
+    )
+    parser.add_argument("--delAckCount", type=int, default=2, help="Delayed ACK count")
+    parser.add_argument("--enablePcap", action="store_true", help="Enable pcap traces")
+    parser.add_argument("--stopTime", type=float, default=100.0, help="Simulation stop time")
+    args = parser.parse_args()
+
+    ts = time.strftime("%d-%m-%Y-%I-%M-%S")
+    outdir = f"bbr-results/{ts}/"
+    os.makedirs(outdir, exist_ok=True)
+
+    tcpType = args.tcpTypeId
+    queueDisc = "ns3::FifoQueueDisc"
+    delAck = args.delAckCount
+    enablePcap = args.enablePcap
+    stopTime = ns.Seconds(args.stopTime)
+
+    ns.Config.SetDefault(
+        "ns3::TcpL4Protocol::SocketType",
+        ns.StringValue("ns3::" + tcpType),
+    )
+    ns.Config.SetDefault("ns3::TcpSocket::SndBufSize", ns.UintegerValue(4194304))
+    ns.Config.SetDefault("ns3::TcpSocket::RcvBufSize", ns.UintegerValue(6291456))
+    ns.Config.SetDefault("ns3::TcpSocket::InitialCwnd", ns.UintegerValue(10))
+    ns.Config.SetDefault("ns3::TcpSocket::DelAckCount", ns.UintegerValue(delAck))
+    ns.Config.SetDefault("ns3::TcpSocket::SegmentSize", ns.UintegerValue(1448))
+    ns.Config.SetDefault(
+        "ns3::DropTailQueue<Packet>::MaxSize", ns.QueueSizeValue(ns.QueueSize("1p"))
+    )
+    ns.Config.SetDefault(
+        queueDisc + "::MaxSize",
+        ns.QueueSizeValue(ns.QueueSize("100p")),
+    )
+
+    sender = ns.NodeContainer()
+    receiver = ns.NodeContainer()
+    routers = ns.NodeContainer()
+    sender.Create(1)
+    receiver.Create(1)
+    routers.Create(2)
+
+    bottleneck = ns.PointToPointHelper()
+    bottleneck.SetDeviceAttribute("DataRate", ns.StringValue("10Mbps"))
+    bottleneck.SetChannelAttribute("Delay", ns.StringValue("10ms"))
+
+    edge = ns.PointToPointHelper()
+    edge.SetDeviceAttribute("DataRate", ns.StringValue("1000Mbps"))
+    edge.SetChannelAttribute("Delay", ns.StringValue("5ms"))
+
+    senderEdge = edge.Install(sender.Get(0), routers.Get(0))
+    r1r2 = bottleneck.Install(routers.Get(0), routers.Get(1))
+    receiverEdge = edge.Install(routers.Get(1), receiver.Get(0))
+
+    inet = ns.InternetStackHelper()
+    inet.Install(sender)
+    inet.Install(receiver)
+    inet.Install(routers)
+
+    tch = ns.TrafficControlHelper()
+    tch.SetRootQueueDisc(queueDisc)
+    tch.SetQueueLimits("ns3::DynamicQueueLimits", "HoldTime", ns.StringValue("1000ms"))
+    tch.Install(senderEdge)
+    tch.Install(receiverEdge)
+
+    ipv4 = ns.Ipv4AddressHelper()
+    ipv4.SetBase(ns.Ipv4Address("10.0.0.0"), ns.Ipv4Mask("255.255.255.0"))
+
+    _ = ipv4.Assign(r1r2)
+
+    ipv4.NewNetwork()
+    ipv4.Assign(senderEdge)
+
+    ipv4.NewNetwork()
+    ir1 = ipv4.Assign(receiverEdge)
+
+    ns.Ipv4GlobalRoutingHelper.PopulateRoutingTables()
+
+    port = 50001
+
+    source = ns.BulkSendHelper(
+        "ns3::TcpSocketFactory",
+        ns.InetSocketAddress(ir1.GetAddress(1), port).ConvertTo(),
+    )
+    source.SetAttribute("MaxBytes", ns.UintegerValue(0))
+    sourceApps = source.Install(sender.Get(0))
+    sourceApps.Start(ns.Seconds(0.1))
+    sourceApps.Stop(stopTime)
+
+    sink = ns.PacketSinkHelper(
+        "ns3::TcpSocketFactory",
+        ns.InetSocketAddress(ns.Ipv4Address.GetAny(), port).ConvertTo(),
+    )
+    sinkApps = sink.Install(receiver.Get(0))
+    sinkApps.Start(ns.Seconds(0))
+    sinkApps.Stop(stopTime)
+
+    if enablePcap:
+        os.makedirs(os.path.join(outdir, "pcap"), exist_ok=True)
+
+    throughput_file = open(os.path.join(outdir, "throughput.dat"), "w")
+    queue_file = open(os.path.join(outdir, "queueSize.dat"), "w")
+    cwnd_file = open(os.path.join(outdir, "cwnd.dat"), "w")
+
+    if enablePcap:
+        bottleneck.EnablePcapAll(os.path.join(outdir, "pcap", "bbr"), True)
+
+    flowmon = ns.FlowMonitorHelper()
+    monitor = flowmon.InstallAll()
+
+    tch.Uninstall(routers.Get(0).GetDevice(1))
+    qdc = tch.Install(routers.Get(0).GetDevice(1))
+
+    prev_time = ns.Now()
+    prev_tx = 0
+
+    ns.cppyy.gbl.monitor_ptr = monitor
+    ns.cppyy.gbl.qdisc_ptr = qdc.Get(0)
+
+    # Define wrapper functions that reschedule themselves
+    def throughput_tracer():
+        """Periodic throughput tracer that reschedules itself."""
+        trace_throughput_callback()
+        event = ns.cppyy.gbl.pythonMakeEvent(throughput_tracer)
+        ns.Simulator.Schedule(ns.Seconds(0.2), event)
+
+    def queue_size_tracer():
+        """Periodic queue size tracer that reschedules itself."""
+        check_queue_size_callback()
+        event = ns.cppyy.gbl.pythonMakeEvent(queue_size_tracer)
+        ns.Simulator.Schedule(ns.Seconds(0.2), event)
+
+    # Schedule initial events using pythonMakeEvent
+    event = ns.cppyy.gbl.pythonMakeEvent(throughput_tracer)
+    ns.Simulator.Schedule(ns.Seconds(0.000001), event)
+
+    event = ns.cppyy.gbl.pythonMakeEvent(queue_size_tracer)
+    ns.Simulator.ScheduleNow(event)
+
+    # Connect cwnd trace after socket is created
+    def connect_cwnd_trace():
+        """Connect the cwnd trace callback."""
+        ns.cppyy.gbl.pythonConnectCwndTrace(trace_cwnd_callback)
+
+    event = ns.cppyy.gbl.pythonMakeEvent(connect_cwnd_trace)
+    ns.Simulator.Schedule(ns.Seconds(0.1) + ns.MilliSeconds(1), event)
+
+    ns.Simulator.Stop(stopTime + ns.TimeStep(1))
+    ns.Simulator.Run()
+    ns.Simulator.Destroy()
+
+    throughput_file.close()
+    queue_file.close()
+    cwnd_file.close()
+
+
+if __name__ == "__main__":
+    main()
